package examples;

import javax.ejb.SessionContext;

/**
 *  Demonstration stateless session bean.
 */
public class HelloBean implements javax.ejb.SessionBean {
	private String maquina = "de Ninguem";
	
    public void setSessionContext(SessionContext ctx) {
        System.out.println("setSessionContext()");
		
		// Aproveite para ler variveis de ambiente (opcional)
		try {
			javax.naming.Context jndi = new javax.naming.InitialContext();
			// Procurando variavel chamada "servidor"
			maquina = (String)jndi.lookup("java:comp/env/servidor");
		} catch (javax.naming.NamingException e) {
			// Ignore. Use o nome da maquina default
		}
		////////////////////
    }

    //
    // EJB-required methods
    //
    public void ejbCreate() {
        System.out.println("ejbCreate()");
    }

    public void ejbRemove() {
        System.out.println("ejbRemove()");
    }

    public void ejbActivate() {
        System.out.println("ejbActivate()");
    }

    public void ejbPassivate() {
        System.out.println("ejbPassivate()");
    }

    //
    // Business methods
    //
    public String hello() {
        System.out.println("hello() foi chamado!");
        return "Hello, World!";
    }
    
    public String byeBye(String usuario) {
		System.out.println("byeBye foi chamado por " + usuario);
        return "Bem vindo a maquina "+maquina+", " + usuario;
    }
}

