package j2eetut.converter;

/*
 *
 * Copyright 2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 *
 */

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.math.BigDecimal;

public class ConverterClient {

   public static void main(String[] args) {
       try {
           
           System.getProperties().load(ClassLoader.getSystemResourceAsStream("client.properties"));
           
           Context initial = new InitialContext();
           //Context myEnv = (Context)initial.lookup("java:comp/env");
           Context myEnv = initial;
           Object objref = myEnv.lookup("services/Currency"); // this is hardwired!!!

           ConverterHome home =
               (ConverterHome)PortableRemoteObject.narrow(objref, ConverterHome.class);

           ConverterRemote currencyConverter = home.create();

           BigDecimal param = new BigDecimal ("100.00");
           BigDecimal amount = currencyConverter.dollarToYen(param);
           System.out.println("US$100.00 equals Y$" + amount);
           amount = currencyConverter.yenToEuro(amount);
           System.out.println("US$100.00 equals EUR$" + amount);
           amount = currencyConverter.dollarToReal(param);
           System.out.println("US$100.00 equals R$" + amount);

           System.exit(0);

       } catch (Exception ex) {
           System.err.println("Caught an unexpected exception!");
           ex.printStackTrace();
       }
   }
}
