package taskdemo;

import java.io.*;
import org.apache.tools.ant.*;

import junit.framework.*;

public class ChangeCaseTaskTest extends TestCase {
    
    private ChangeCaseTask task;
    
    public ChangeCaseTaskTest(java.lang.String testName) {
        super(testName);
    }
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    public static Test suite() {
        return new TestSuite(ChangeCaseTaskTest.class);
    }
    
    public void setUp() {
        task = new ChangeCaseTask();
    }
    
    /**
     * This test is left as an exercise. You will have to explore
     * Ant's API to do it.
     * To test this message it is necessary to register a BuildListener
     * object which will receive Ant's BuildEvents. The log() method
     * will save the message in the event's setMessage() method. It
     * can be recovered via the getMessage() method once we have captured
     * the BuildEvent. That means we need to create a BuildListener, 
     * register it with the project, then call the execute method and
     * finally compare the event.getMessage() with the expected result.
     */
    public void testExecute() throws BuildException {
        // Test for exceptions
        try {
            task.execute(); // Message is null - this should fail
            fail("A Build Exception should have occurred!");
        } catch (BuildException e) {
            // Test passed
        }
        setupMessage(); // Message is no longer null
        
        // Test for logging
        fail("This test was not completely implemented. Write it!");
    }
    
    /**
     * This is used only as an additional 'setUp()' method in some tests.
     */
    public void setupMessage() {
        task.setMessage("This is a Message");
    }
    
    public void testSetCase() throws BuildException {
        setupMessage();
        try {
            task.setCase("invalid");
            fail("An Exception should have occurred");
        } catch (BuildException e) {}
        
    }
    
    public void testGetMessage() {
        setupMessage();
        String msg = "This is a Message";
        assertEquals(msg, task.getMessage());
        task.setCase("uppercase");
        assertEquals(msg.toUpperCase(), task.getMessage());
        task.setCase("UPPERCASE");
        assertEquals(msg.toUpperCase(), task.getMessage());
        task.setCase("lowercase");
        assertEquals(msg.toLowerCase(), task.getMessage());
    }
    
}
