package hello.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import org.apache.struts.action.*;
 
/**
 * Opens the message that has the highest index number.
 * $Revision: 1.2 $ $Date: 2002/10/06 22:46:48 $ (helder@acm.org).
 */
public class ShowLastMessageAction extends Action {
    
    private String successTarget = "success";
    private String failureTarget = "default";
    
    /**
     * Gets last message file created.
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, 
                                 HttpServletRequest request, HttpServletResponse response) 
                                 throws IOException, ServletException {
                                     
        try {
            MessageBeanDAO dao = (MessageBeanDAO)request.getAttribute("dao");
            MessageBean bean = dao.retrieveLast(); 
            request.setAttribute("messageBean", bean);
            return (mapping.findForward(successTarget));
        } catch (PersistenceException e) {
            throw new ServletException("Unable to read last message: " + e, e);
        }
    }
    
    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successTarget + "\", \"" + failureTarget + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ShowLastMessageAction) ) return false;
        ShowLastMessageAction cmd = (ShowLastMessageAction) obj;
        return cmd.toString().equals(toString());
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successTarget.hashCode() * failureTarget.hashCode();
    }
}
