package hello.jsp;

import javax.servlet.*; 
import javax.servlet.http.*;
import java.io.*;
import org.apache.struts.action.*;

/**
 * Creates a new message file and increments the message counter.
 * $Revision: 1.3 $ $Date: 2002/10/06 22:46:47 $ (helder@acm.org).
 */
public class NewMessageAction extends Action {
    
    private String successTarget = "success";
    private String failureTarget = "default";
    
    /**
     * Creates a new MessageBean. Sets a request
     * attribute which contains the message that was created.
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, 
                                 HttpServletRequest request, HttpServletResponse response) 
                                 throws IOException, ServletException {
                               
        String message = request.getParameter("message");
        MessageBeanDAO dao = (MessageBeanDAO)request.getAttribute("dao");
        String time = java.text.DateFormat.getDateTimeInstance(java.text.DateFormat.MEDIUM, java.text.DateFormat.SHORT).format(new java.util.Date());
        String host = request.getRemoteHost();
        
        MessageBean bean = new MessageBean();
        
        bean.setMessage(message);
        bean.setTime(time);
        bean.setHost(host);
        
        try {
            // Data tier independent persistent mechanism. Althoug bean has built in XML binding
            // capabilities, we may wish, in the future, to save the data, for example, in a database
            dao.persist(bean);
            request.setAttribute("messageBean", bean);
            return (mapping.findForward(successTarget));
        } catch (PersistenceException e) {
            throw new ServletException(e);   
        }
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successTarget + "\", \"" + failureTarget+ "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof NewMessageAction) ) return false;
        NewMessageAction cmd = (NewMessageAction) obj;
        return cmd.toString().equals(toString());
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successTarget.hashCode() * failureTarget.hashCode();
    }
}
