package hello.rmi.server;

import java.rmi.*;
import hello.rmi.RemoteHello;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

/**
 * Esta classe  um servidor que publicar o
 * objeto no RMIRegistry.
 */
public class HelloServer extends JFrame {
    
    private JTextArea  area;
    private String objetoRemoto;
    
    public HelloServer(String objetoRemoto) {
        super("Servidor remoto para objeto: '"+objetoRemoto+"'");
        
        this.objetoRemoto = objetoRemoto;
        
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        area = new JTextArea();
        JScrollPane pane = new JScrollPane(area);
        getContentPane().add(pane);
        try {
            // Cria objeto remoto
            RemoteHello hello = new HelloImpl("Mensagem inicial de "+java.net.InetAddress.getLocalHost()); 
            
            java.util.Properties props = System.getProperties();
            // Esta linha  necessria para que no seja preciso ter o CLASSPATH da aplicao no RMI Registry
            // (O Classpath para esta aplicao contm apenas a raiz do JAR)
            props.setProperty("java.rmi.server.codebase", "file://" + props.getProperty("java.class.path"));
            // Registra objeto remoto no RMIRegistry        
            java.rmi.Naming.rebind(objetoRemoto, hello); 
            area.setText("Servidor no ar, servindo o objeto: " + objetoRemoto);
        } catch (RemoteException e) {
            area.setText("Problemas no registro do objeto.\n Verifique se o RMI Registry est rodando\n"+
                         "e se as classes da aplicao fazem parte do seu CLASSPATH! \n" + e);
        } catch (java.net.MalformedURLException e) {
            throw new InternalError("Erro na aplicaao: " + e);
        } catch (java.net.UnknownHostException e) { /* Local Host */ }
         
        setSize(500,100);
        setVisible(true);

    }
    
    public static void main(String[] args) {
        new HelloServer("mensagens");   
    }
    
}
