package hello.rmiop;

import java.rmi.*;

import hello.*;

public class HelloImpl extends javax.rmi.PortableRemoteObject implements HelloRemote {
    
    private Nome msgObject;
    private Circulo circulo;
    
    public HelloImpl(Nome msgObject, Circulo circulo) throws RemoteException {
        this.msgObject = msgObject;
        this.circulo = circulo;
    }
        
    public String sayHello() throws RemoteException {
        return msgObject.getNome();
    }
    public void sayThis(String toSay) throws RemoteException {
        msgObject.setNome(toSay);
    }
    
    public Nome getMessage() throws RemoteException {
        return msgObject;
    }
    public void setMessage(Nome mensagem)  throws RemoteException {
        msgObject = mensagem;
    }
    
    public Circulo getCirculo()  throws RemoteException {
        return circulo;
    }
    public void setCirculo(Circulo circulo)  throws RemoteException  {
        this.circulo = circulo;
    }
    
    public Circulo createCirculo(int raio, Ponto origem) throws RemoteException {
        return new Circulo(raio, origem);
    }
    public Ponto createPonto(int x, int y) throws RemoteException {
        return new Ponto(x, y);
    }
    public Nome createNome(String nome) throws RemoteException {
        return new Nome(nome);
    }
    
}
