package hello.unicast;

import java.rmi.server.UnicastRemoteObject;
import java.rmi.*;

import hello.*;

/**
 * Implementao de Circulo como objeto remoto RMI-JRMP
 */
public class CirculoImpl extends UnicastRemoteObject implements CirculoRemote {
    private int raio;
    private PontoRemote origem;
    
    public CirculoImpl(int raio, PontoRemote origem) throws RemoteException {
        this.raio = raio;
        this.origem = origem;
    }
    
    public int getRaio() throws RemoteException {
        return raio;
    }
    
    public PontoRemote getOrigem() throws RemoteException {
        return origem;
    }
    
    public void setOrigem(PontoRemote p) throws RemoteException {
        origem = p;
    }
    
    public void setRaio(int raio) throws RemoteException {
        this.raio = raio;
    }
    
    public String toStringRemote() throws RemoteException {
        return "Circulo de raio " + raio + " em " + origem.toStringRemote() + ".";
    }
    
    public boolean equalsRemote(Object obj) throws RemoteException {
        if ( !(obj instanceof CirculoRemote)) return false;
        CirculoRemote outro = (CirculoRemote) obj;
        return raio == outro.getRaio() && origem.equals(outro.getOrigem());
    }
}
