package loja;

import java.math.BigDecimal;
import java.rmi.*;

public class ProdutoImpl extends javax.rmi.PortableRemoteObject
                       			 implements Produto {
	
	private String codigo;
	private String nome;
	private BigDecimal preco;
	private int quantidade;
	
	public ProdutoImpl()  throws RemoteException {}
	
	public ProdutoImpl(String codigo, String nome, BigDecimal preco, int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl("+codigo+","+nome+","+preco+","+quantidade+")");
		this.codigo = codigo;
		this.nome = nome;
		this.preco = preco;
		this.quantidade = quantidade;
	}

	public String getCodigo()  throws RemoteException {
		System.out.println("ProdutoImpl: getCodigo()");
		return codigo;
	}
	public void setCodigo(String codigo)  throws RemoteException {
		System.out.println("ProdutoImpl: setCodigo("+codigo+")");
		this.codigo = codigo;
	}
	
	public void setNome(String nome)  throws RemoteException {
		System.out.println("ProdutoImpl: setNome("+nome+")");
		this.nome = nome;
	}
	public String getNome()  throws RemoteException {
		System.out.println("ProdutoImpl: getNome()");
		return nome;
	}
	
	public void setPreco(BigDecimal preco)  throws RemoteException {
		System.out.println("ProdutoImpl: setPreco("+preco+")");
		this.preco = preco;
	}
	public BigDecimal getPreco()  throws RemoteException {
		System.out.println("ProdutoImpl: getPreco()");
		return preco;
	}
	
	public int getQuantidade()  throws RemoteException {
		System.out.println("ProdutoImpl: getQuantidade()");
		return quantidade;
	}
	public void setQuantidade(int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl: setQuantidade("+quantidade+")");
		this.quantidade = quantidade;
	}
	
	public void addItens(int quantidade)  throws RemoteException {
		System.out.println("ProdutoImpl: addItens("+quantidade+")");
		this.quantidade += quantidade;
	}
	
	public String toString() {
		return "["+codigo+"] " + nome + "($"+preco+"). Estoque: "+quantidade;
	}

}
