package client;

import loja.*;
import javax.naming.*;
import java.math.BigDecimal;

/**
 * Obtem uma fabrica de produtos e, atraves dela, cria alguns
 * produtos remotos.
 */
public class ProdutoClient {
	
	public static String jndiName = "loja/produtos";
    
    public static void main(String[] args) throws Exception {
		String hostname = "localhost";
		if (args.length > 0) {
			hostname = args[0];
		}
        try {
			Context ctx = new InitialContext();
            Object obj = ctx.lookup(jndiName);
            CarrinhoHome home = (CarrinhoHome) 
				javax.rmi.PortableRemoteObject.narrow(obj, ProdutoFactory.class);
				
			Carrinho carrinho = home.create();
			
			ProdutoVO[] p = new ProdutoVO[3];
			p[0] = new ProdutoVO("1", "Folhas de Cactus", new BigDecimal(30.00), 5);
			p[1] = new ProdutoVO("2", "Comida digital", new BigDecimal(120.00), 3);
			p[2] = new ProdutoVO("3", "Vento em garrafa", new BigDecimal(17.00), 12);
			
			System.out.println("----- Produtos criados -----");
			for (int i = 0; i < p.length; i++) {
				System.out.println("Produto: cdigo: " + p[i].getCodigo() +
											"; nome: " + p[i].getNome() + 
											"; preco: $" + p[i].getPreco() + 
											"; qte.: " + p[i].getQuantidade());
			}
			
			// 1. Liste conteudo do carrinho
			// 2. Adicione alguns produtos
			// 3. Liste conteudo do carrinho
			// 4. Remova alguns produtos
			// 5. Liste conteudo do carrinho
        
        } catch (NamingException e) {
            System.out.println("Erro de JNDI:  " + e + ".\n");
        } catch (RemoteException e) {
            System.out.println("Erro de comunicao com o servidor: " + e + "\n");
        } catch (Exception e) { 
			System.out.println("Erro: " + e + "\n");
     	}
    }
}
