package loja;

import javax.ejb.*;
import java.util.*;

public abstract class ProdutoBean implements EntityBean {

	// get/set
	public abstract String getNome();
	public abstract void setNome(String name);
	
    public abstract String getCodigo();
	public abstract void setCodigo(String codigo);
	
	public abstract double getPreco();
	public abstract void setPreco(double preco);
	
	public abstract int getQuantidade();
	public abstract void setQuantidade(int quantidade);
	
	// business
	public void addItens(int quantidade) {
		setQuantidade( getQuantidade() + quantidade);
	}
	
	// spec
	public void ejbActivate() {
		System.out.println("ejbActivate() called.");
	}
	public void ejbRemove() {
		System.out.println("ejbRemove() called.");
	}
	public void ejbPassivate() {
		System.out.println("ejbPassivate () called.");
	}
	public void ejbLoad() {
		System.out.println("ejbLoad() called.");
	}
	public void ejbStore() {
		System.out.println("ejbStore() called.");
	}
	public void setEntityContext(EntityContext ctx) {
		System.out.println("setEntityContext called");
	}
	public void unsetEntityContext() {
		System.out.println("unsetEntityContext called");
	}
	public void ejbPostCreate(String codigo, String nome, double preco, int quantidade) {
		System.out.println("ProdutoBean-ejbPostCreate()");
	}
	public ProdutoPK ejbCreate(String codigo, String nome, double preco, int quantidade) throws CreateException {
		System.out.println("ejbCreate() called");
		setCodigo(codigo);
		setNome(nome);
		setPreco(preco);
		setQuantidade(quantidade);
		return null;
	}
	
	// Home
	
	public abstract Collection ejbSelectCodigos() throws FinderException;

	public String ejbHomeGetProximoCodigo() throws FinderException {
		Collection codigos = this.ejbSelectCodigos();
		Iterator it = codigos.iterator();
		int max = 0;
		while(it.hasNext()) {
			int cod = Integer.parseInt((String)it.next());
			if (cod > max) max = cod;
		}
		return "" + (max+1);
	}

}

