import javax.naming.*;
import javax.jms.*;

public class ReceiverClient {

    public static void main(String[] args) throws Exception {

        Context ctx = new InitialContext();
        QueueConnectionFactory factory =
             (QueueConnectionFactory) ctx.lookup("ConnectionFactory"); 
        QueueConnection connection =  factory.createQueueConnection();
        QueueSession session = connection.createQueueSession(
                               false, Session.AUTO_ACKNOWLEDGE);
        Queue queue = (Queue) ctx.lookup("queue/A");
		String seletor = "Quantidade > 100";
		QueueReceiver receiver = session.createReceiver(queue, seletor);
		connection.start();
		
		System.out.println("Vou receber mensagens...");
		Message message = null;
		while ( (message = receiver.receive()) != null) {
			TextMessage msg = (TextMessage)message;
			try {
				String text = msg.getText();
				String quantidade = msg.getStringProperty("Quantidade");
				int codigo = msg.getIntProperty("Codigo");
				System.err.println("Produto "+codigo+" tem "+quantidade+" unidades em estoque. Descricao: " + text);
			} catch (JMSException e) {
				e.printStackTrace();
				break;
			}
		}
		connection.close();
    }
}
