package j2eetut.salesrep;

/*
 *
 * Copyright 2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class SalesRepClient {

   public static void main(String[] args) {

      try {

         Context initial = new InitialContext();

         Object objref = initial.lookup("examples/SimpleSalesRep");
         SalesRepHome salesHome = 
             (SalesRepHome)PortableRemoteObject.narrow(objref, 
                                          SalesRepHome.class);

         objref = initial.lookup("examples/SimpleCustomer");
         CustomerHome customerHome =
             (CustomerHome)PortableRemoteObject.narrow(objref,
                                          CustomerHome.class);

         Customer buzz = customerHome.create("844", "543", "Buzz Murphy");

         Collection c = customerHome.findBySalesRep("543");
         Iterator i = c.iterator();

         while (i.hasNext()) {
            Customer customer = (Customer)i.next();
            String customerId = (String)customer.getPrimaryKey();
            System.out.println("customerId = " + customerId);
         }

         System.out.println();
         Customer mary = customerHome.findByPrimaryKey("987");
         mary.setSalesRepId("543");

         Customer x = customerHome.findByPrimaryKey("987");
         SalesRep janice = salesHome.findByPrimaryKey("543");
         ArrayList a = janice.getCustomerIds();

         i = a.iterator();

         while (i.hasNext()) {
            String customerId = (String)i.next();
            Customer customer = customerHome.findByPrimaryKey(customerId);
            String name = customer.getName();
            System.out.println(customerId + ": " + name);
         }

         System.exit(0);

      } catch (Exception ex) {
          System.err.println("Caught an exception." );
          ex.printStackTrace();
      }
   } 

} 
