package loja;

import javax.ejb.*;
import java.rmi.RemoteException;
import java.util.Collection;

/**
 *  This is the home interface for Product. This interface is implemented by the
 *  EJB Server's glue-code tools. The implemented object is called the Home
 *  Object, and serves as a factory for EJB Objects. One create() method is in
 *  this Home Interface, which corresponds to the ejbCreate() method in the
 *  Product file.
 *
 *@created    9 de Julho de 2002
 */

public interface ProdutoHome extends EJBHome {

    /*
     *  Creates a product
     *
     *  @param productID The number of the product (unique)
     *  @param name The name of the product
     *  @param description Product description
     *  @param basePrice Base Price of product
     *
     *  @return The newly created EJB Object.
     */
    Produto create(String codigo, String nome, double preco, int quantidade) throws CreateException, RemoteException;

    // Finder methods.  These are implemented by the
    // container.  You can customize the functionality of
    // these methods by using the EJB Container tools.

    public Produto findByPrimaryKey(ProdutoPK key) throws FinderException, RemoteException;
    public Collection findByNome(String name) throws FinderException, RemoteException;
    public Collection findByPreco(double min, double max) throws FinderException, RemoteException;
    public Collection findAllProdutos() throws FinderException, RemoteException;

	public String getProximoCodigo() throws RemoteException;
}

