package j2eetut.bank;

/*
 *
 * Copyright 2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class BankClient {

   public static void main(String[] args) {

       try {
           Context initial = new InitialContext();
           Object objref = initial.lookup("examples/SimpleBank");

           BankHome home = 
               (BankHome)PortableRemoteObject.narrow(objref, 
                                            BankHome.class);

           Bank duke = home.create("123");
           duke.transferToSaving(40.00);
           System.out.println("checking: " + duke.getCheckingBalance());
           System.out.println("saving: " + duke.getSavingBalance());

           duke.remove();

           System.exit(0);

       } catch (Exception ex) {
           System.err.println("Caught an exception." );
           ex.printStackTrace();
       }
   } 
} 
