<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="html" encoding="iso-8859-1" />

	<xsl:template match="project">
		<html>
		 	<head>
				<title><xsl:value-of select="@name" /></title>
				<style>
					.main-description {width: 950px}
					table {width: 950px; margin-top: 20px}
					.comando {font-weight: bold; color: red}
				</style>
			</head>
			<body>
			<h1><xsl:value-of select="@name" /></h1>
			<p>Documento gerado a partir de <b>build.xml</b>.</p>
			<div class="main-description"><xsl:apply-templates select="description" /></div>
			<h2>Properties</h2>
			<p><table border="1" width="100%">
			<tr><td><b>Name</b></td><td><b>Value</b></td></tr>
			<xsl:apply-templates select="property" />
			</table></p>
			<h2>Patterns</h2>
			<p><table border="1" width="100%">
			<xsl:apply-templates select="patternset" />
			</table></p>
			<h2>Paths</h2>
			<p><table border="1" width="100%">
			<xsl:apply-templates select="path" />
			</table></p>
			<h2>Targets</h2>
			<p><table border="1" width="100%">
			<tr><td><b>Target</b></td><td><b>Depends</b></td></tr>
			<xsl:apply-templates select="target" />
			</table></p>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="path">
		<div class="grupo">
				<tr><td class="comando"><xsl:value-of select="@id" /></td>
				<td><xsl:value-of select="@description" /></td></tr>
		</div>
	</xsl:template>
	
	<xsl:template match="patternset">
				<tr><td class="comando"><xsl:value-of select="@id" /></td>
				<td><xsl:value-of select="@description" /></td></tr>
	</xsl:template>
	
	<xsl:template match="property[@name]">
				<tr><td class="comando"><xsl:value-of select="@name" /></td>
				    <td><xsl:value-of select="@value" /></td></tr>
	</xsl:template>
	
	<xsl:template match="target">
				<tr><td class="comando"><xsl:value-of select="@name" /></td>
				    <td><xsl:value-of select="@depends" /></td></tr>
				<tr><td colspan="2"><xsl:value-of select="@description" /></td></tr>
	</xsl:template>
	
</xsl:stylesheet>
