<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="html" encoding="iso-8859-1" />

	<xsl:template match="command-mapping">
		<html>
		 	<head>
				<title><xsl:value-of select="display-name" /></title>
				<style>
					.main-description {width: 950px}
					.grupo {width: 950px; margin-top: 20px}
					.tipo-comando {font-size: 14pt; font-weight: bold}
					.comandos {font-size: 9pt; font-family: monospace;}
					.comando {font-weight: bold; color: red}
					.classe  {color: black}
					.success {font-weight: bold; color: green}
					.fail    {font-weight: bold; color: maroon}
				</style>
			</head>
			<body>
			<h1><xsl:value-of select="display-name" /></h1>
			<p>Documento gerado a partir de <b>mapping.xml</b>.</p>
			<div class="main-description"><xsl:apply-templates select="description" /></div>
			<xsl:apply-templates select="group" />
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="p">
		<p><xsl:apply-templates /></p>
	</xsl:template>
	
	<xsl:template match="group">
		<div class="grupo">
			<p><table width="100%">
				<tr><td class="tipo-comando"><xsl:value-of select="name" /></td></tr>
				<tr><td><b>Servlets: </b><xsl:apply-templates select="servlets" /></td></tr>
				<tr><td><xsl:apply-templates select="description" /></td></tr>
				<tr><td><table border="1" width="100%">
				<tr><td><b>/servlet?cmd=</b></td><td><b>Objeto Command chamado</b></td><td><b>successUrl</b></td><td><b>failureUrl</b></td></tr>
				<xsl:apply-templates select="command" />
				</table></td></tr>
			</table></p>
		</div>
	</xsl:template>
	
	<xsl:template match="servlets">
		<xsl:for-each select="servlet">
			<xsl:value-of select="." />
			<xsl:if test="not(position()=last())">
				<xsl:text>, </xsl:text>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="command">
		<tr class="comandos">
			<td class="comando"><xsl:value-of select="name" /></td>
			<td class="classe"><xsl:value-of select="class" /></td>
			<td class="success"><xsl:value-of select="success-url" /></td>
			<td class="fail"><xsl:value-of select="failure-url" /></td>
			<td></td>
		</tr>
		<tr>
			<td colspan="4"><table width="100%">
				<tr>
					<td><i><xsl:value-of select="description" /></i></td>
				</tr>
			</table></td>
		</tr>
	</xsl:template>
	
</xsl:stylesheet>
