package loja;

import loja.integration.ServiceLocator;
import loja.ejb.*;

import java.math.BigDecimal;

public class AdminLojaBusinessDelegate implements BusinessDelegate {
	
	AdminLojaSessionFacade facade;
	
	public AdminLojaBusinessDelegate() throws LojaException {
		ServiceLocator locator = ServiceLocator.getInstance();
		AdminLojaSessionFacadeHome home = (AdminLojaSessionFacadeHome)
			locator.findRemoteEJB("ejb/loja/admin", AdminLojaSessionFacadeHome.class);
		try {
			facade = home.create();
			if (facade == null) {
				throw new LojaException("Fachada eh null!");
			}
		} catch (javax.ejb.CreateException e) {
			throw new LojaException(e);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		}
	}
	
	public String criarProduto(String nome, BigDecimal preco) throws LojaException {
		try {
			return facade.criarProduto(nome, preco);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void removerProduto(String codigo) throws LojaException {
		try {
			facade.removerProduto(codigo);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	public ProdutoVO[] listarProdutos() throws LojaException {
		try {
			return facade.listarProdutos();
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public CompraVO[] listarCompras() throws LojaException {
		try {
			return facade.listarCompras();
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public CompraVO[] listarCompras(String userid) throws LojaException {
		try {
			return facade.listarCompras(userid);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public CompraVO mostrarCompra(String numero) throws LojaException {
		try {
			return facade.mostrarCompra(numero);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void alterarStatus(String compraId, Status status) throws LojaException {
		try {
			facade.alterarStatus(compraId, status);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public ClienteVO mostrarCliente(String userid) throws LojaException {
		try {
			return facade.mostrarCliente(userid);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public ClienteVO[] listarClientes() throws LojaException {
		try {
			return facade.listarClientes();
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void solicitarCompra(String codigo, int quantidade) throws LojaException  {
		try {
			facade.solicitarCompra(codigo, quantidade);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void esvaziarEstoque(String codigo) throws LojaException {
		try {
			facade.esvaziarEstoque(codigo);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void removerCompra(String numero) throws LojaException {
		try {
			facade.removerCompra(numero);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void removerCliente(String userid) throws LojaException {
		try {
			facade.removerCliente(userid);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
}
