package loja;

import java.math.BigDecimal;
import java.util.*;

public class CompraVO implements java.io.Serializable {
	
	private String numero;
	private String clienteId;
	private Status status;
	private List itensList;
	
	private static int contador = 0;
	
	public CompraVO() {
		itensList = new ArrayList();
		this.numero = "9999"+(++contador); // default (apenas para nao deixar com 0)
	}

	public CompraVO(String numero, String clienteId, Status status) {
		this();
		this.numero = numero; // numero real
		this.clienteId = clienteId;
		this.status = status;
		itensList = new ArrayList();
	}

	public String getNumero() {
		return numero;
	}
	public void setNumero(String numero) {
		this.numero = numero;
	}
	
	public void setClienteId(String clienteId) {
		this.clienteId = clienteId;
	}
	public String getClienteId() {
		return clienteId;
	}
	
	public void setStatus(Status status) {
		this.status = status;
	}
	public Status getStatus() {
		return status;
	}
	
	// Mtodos abaixo no so usados pela implementao EJB
	public ItemVO[] getItens() {
		Iterator it = itensList.iterator();
		List itensList = new ArrayList();
		while (it.hasNext()) {
			ItemVO item = (ItemVO)it.next();
			itensList.add(item);
		}
		ItemVO[] buffer = new ItemVO[itensList.size()];
		return (ItemVO[]) itensList.toArray(buffer);
	}
	
	public void setItens(ItemVO[] itens) {
		itensList.clear();
		for (int i = 0; i < itens.length; i++) {
			itensList.add(itens[i]);
		}
	}
	
	public java.math.BigDecimal getTotal() {
		Iterator it = itensList.iterator();
		BigDecimal total = new BigDecimal(0.0);
		while (it.hasNext()) {
			ItemVO item = (ItemVO)it.next();
			total = total.add(item.getSubTotal());
		}
		return total;
	}
	
	// Metodos afetam objeto local (desatualizado em relacao ao objeto remoto)
	public void addItem(ItemVO item) {
		itensList.add(item);
	}
	public void removeItem(ItemVO item) {
		itensList.remove(item);
	}
	
	public int hashCode() {
		return Integer.parseInt(numero) * 37;
	}
	
	public boolean equals(Object o) {
		if (!(o instanceof CompraVO)) return false;
		CompraVO p = (CompraVO) o;
		return p.numero.equals(numero);
	}
	
	public String toString() {
		String total = "$" + getTotal();
		String itensStr = "";
		Iterator it = itensList.iterator();
		while (it.hasNext()) {
			ItemVO item = (ItemVO)it.next();
			itensStr += "\n"+item;
		}
		return "Compra no. "+numero+" ("+status+"); Cliente: " + clienteId + itensStr + "\nTOTAL: " + total;
	}

}
