package loja;

public class ItemCarrinho implements java.io.Serializable {
	
	private int quantidade;
	private ProdutoVO produto;
	
	public ItemCarrinho() {}
	
	public ItemCarrinho(ProdutoVO produto, int quantidade) {
		this.produto = produto;
		this.quantidade = quantidade;
	}
	
	public ProdutoVO getProduto() {
		return produto;
	}
	
	public int getQuantidade() { 
		return quantidade;
	}
	
	public void setProduto(ProdutoVO produto) {
		this.produto = produto;
	}
	
	public void setQuantidade(int quantidade) {
		this.quantidade = quantidade;
	}
	
	public int hashCode() {
		return produto.hashCode() * quantidade;
	}
	
	public boolean equals(Object o) {
		if (!(o instanceof ItemCarrinho)) return false;
		ItemCarrinho p = (ItemCarrinho) o;
		return p.produto.equals(produto) && p.quantidade == quantidade;
	}
	
	public String toString() {
		return produto + "[" + quantidade + " no carrinho]";
	}
}
