package loja;

import loja.integration.ServiceLocator;
import loja.ejb.*;

import java.math.BigDecimal;

public class LoginBusinessDelegate implements BusinessDelegate {
	
	LoginSessionFacade facade;
	
	public LoginBusinessDelegate() throws LojaException {
		ServiceLocator locator = ServiceLocator.getInstance();
		LoginSessionFacadeHome home = (LoginSessionFacadeHome)
			locator.findRemoteEJB("ejb/loja/login", LoginSessionFacadeHome.class);
		try {
			facade = home.create();
			if (facade == null) {
				throw new LojaException("Fachada eh null!");
			}
		} catch (javax.ejb.CreateException e) {
			throw new LojaException(e);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		}
	}

	/**
	 * Login simples sem usar JAAS.
	 */
	public boolean simpleLogin(String nome, String senha) throws LojaException {
		try {
			return facade.simpleLogin(nome, senha);
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void cadastrar(ClienteVO cliente) throws LojaException {
		try {
			facade.cadastrar(cliente) ;
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public void atualizar(ClienteVO cliente) throws LojaException {
		try {
			facade.atualizar(cliente) ;
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public ClienteVO mostrar(String userid) throws LojaException {
		try {
			return facade.mostrar(userid) ;
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public String getCurrentUserid() throws LojaException {
		try {
			return facade.getCurrentUserid() ;
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
	
	public boolean existe(String userid) throws LojaException {
		try {
			return facade.existe(userid) ;
		} catch (java.rmi.RemoteException e) {
			throw new LojaException(e);
		} 
	}
}
