package loja.client;

import loja.*;
import loja.security.Authenticator;

import java.math.BigDecimal;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;

public class LoginClient {
	
	public static void main(String[] args) throws LojaException {
		
		LoginBusinessDelegate login = new LoginBusinessDelegate();
		
		// Versao antiga - nao usa JAAS
		
		ClienteVO cliente = new ClienteVO("helder", "redleh", "admin", "Helder da Rocha", "helder@localhost", "Rua Java, 530 - Sao Paulo", "1234567890123456");
		try {
			login.cadastrar(cliente);
			System.out.println("Helder cadastrado!");
		} catch (UsuarioJaExisteException e) {
			System.out.println(""+e);
		}
		ClienteVO cliente2 = new ClienteVO("outro", "outro", "usuario", "Outro Usuario", "helder@localhost", "Rua dos Outros, 111 - Sao Paulo", "1234567890123456");
		
		try {
			login.cadastrar(cliente2);
			System.out.println("Outro cadastrado!");
		} catch (UsuarioJaExisteException e) {
			System.out.println(""+e);
		}

		boolean sim = login.simpleLogin("helder", "redleh");
		System.out.println("Login para helder/redleh: " + sim);
	
		boolean nao = login.simpleLogin("helder", "boo");
		System.out.println("Login para helder/boo: " + nao);
		
		// Versao com JAAS
		
		// A parte seguinte funciona se cliente enxergar arquivo de configuracao que estah no lib/
		// deste ambiente de desenvolvimento, e se servidor estiver configurado.
		// Veja build XML onde seguinte propriedade eh passada:
		// java.security.auth.login.config=lib/client-auth.conf
		System.out.println("Login via JAAS");
        
		try {
			Authenticator.login("helder", "redleh");
		} catch (LoginException e) {
			System.out.println("Login falhou");
			System.exit(1);
		}

		System.out.println("Executando metodo privilegiado...");
		String quemSou = login.getCurrentUserid();
		System.out.println("Caller principal retornado pelo servidor que identifica usuario autenticado: " + quemSou);
		
    }
}
