package loja.ejb;

import javax.ejb.*;
import java.rmi.RemoteException;
import java.math.BigDecimal;

import loja.*;

public interface AdminLojaSessionFacade extends EJBObject {
	
	public String criarProduto(String nome, BigDecimal preco) throws LojaException, RemoteException;
	public void solicitarCompra(String codigo, int quantidade) throws LojaException, RemoteException;
	public void esvaziarEstoque(String codigo) throws LojaException, RemoteException;
	public void alterarStatus(String compraId, Status status) throws LojaException, RemoteException;
	
	public ProdutoVO[] listarProdutos() throws LojaException, RemoteException;
	public CompraVO[]  listarCompras() throws LojaException, RemoteException;
	public CompraVO[]  listarCompras(String userid) throws LojaException, RemoteException;
	public ClienteVO[] listarClientes() throws LojaException, RemoteException;
	
	public void removerProduto(String codigo) throws LojaException, RemoteException;
	public void removerCliente(String userid) throws LojaException, RemoteException;
	public void removerCompra(String numero) throws LojaException, RemoteException;
	
	public ProdutoVO mostrarProduto(String codigo) throws LojaException, RemoteException;	
	public CompraVO mostrarCompra(String numero) throws LojaException, RemoteException;	
	public ClienteVO mostrarCliente(String userid) throws LojaException, RemoteException;
}
