package loja.ejb;

import javax.ejb.*;
import java.math.BigDecimal;

import loja.*;

public interface AdminLojaSessionFacadeLocal extends EJBLocalObject {
	
	public String criarProduto(String nome, BigDecimal preco) throws LojaException;
	public void solicitarCompra(String codigo, int quantidade) throws LojaException;
	public void esvaziarEstoque(String codigo) throws LojaException;
	public void alterarStatus(String compraId, Status status) throws LojaException;
	
	public ProdutoVO[] listarProdutos() throws LojaException;
	public CompraVO[]  listarCompras() throws LojaException;
	public CompraVO[]  listarCompras(String userid) throws LojaException;
	public ClienteVO[] listarClientes() throws LojaException;
	
	public void removerProduto(String codigo) throws LojaException;
	public void removerCliente(String userid) throws LojaException;
	public void removerCompra(String numero) throws LojaException;
	
	public ProdutoVO mostrarProduto(String codigo) throws LojaException;	
	public CompraVO mostrarCompra(String numero) throws LojaException;	
	public ClienteVO mostrarCliente(String userid) throws LojaException;
}
