package loja.ejb;

import javax.ejb.*;

import java.math.BigDecimal;

public interface CompraLocal extends EJBLocalObject {
	
	// Atributo e PK
	public String getNumero();
	public void setNumero(String numero);
	
	public loja.Status getStatus();
	public void setStatus(loja.Status status);
	
	// Relacionamento com objeto Cliente apenas envolve FK - lazy
	// Usuario do bean tera que buscar dados do Cliente por conta propria
	public String getClienteId();
	public void setClienteId(String clienteId);
	
	// Relacionamentos 1 compra : N itens
	public ItemLocal[] getItens();
	public void setItens(ItemLocal[] itens);
	
	public void addItem(ItemLocal item);
	public void removeItem(ItemLocal item);
	
	public BigDecimal getTotal();
	
}
