package loja.security;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;

public final class Authenticator {

	private Authenticator() {}

	/**
	 * Faz a autenticacao via JAAS
	 */
    public static LoginContext login(String nome, String senha) throws LoginException {
        CallbackHandler handler = new SimpleCallbackHandler(nome, senha);
		// dominio-login-cliente: este nome estah no client-auth.conf
        LoginContext loginCtx = new LoginContext("dominio-login-cliente", handler); 
        System.out.println("Created LoginContext");
        loginCtx.login();
		System.out.println("Logado no sistema!");
		return loginCtx;
    }
	
}
