package loja.security;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;

public class SimpleCallbackHandler implements CallbackHandler {
    private String username;
    private String password;


    public SimpleCallbackHandler(String nome, String senha) {
        this.username = nome;
        this.password = senha;
    }

    public void handle(Callback[] callbacks) throws
            java.io.IOException, UnsupportedCallbackException {
        for (int i = 0; i < callbacks.length; i++) {
            if (callbacks[i] instanceof NameCallback) {
                NameCallback nc = (NameCallback) callbacks[i];
                nc.setName(username);
            } else if (callbacks[i] instanceof PasswordCallback) {
                PasswordCallback pc = (PasswordCallback) callbacks[i];
                pc.setPassword( preparePassword(password) );
            } else {
                throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
            }
        }
    }
    
    /**
     * Pode ser usado para criptografar a senha antes de enviar.
     */
    private char[] preparePassword(String word) {
        return word.toCharArray();
    }
}

