package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.2 $ $Date: 2003/05/26 08:22:22 $ (helder@acm.org).
 */
public class AdicionarProdutoCarrinhoCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public AdicionarProdutoCarrinhoCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {
		System.out.println("AdicionarProdutoCarrinhoCommand.execute()");
		
		LojaBusinessDelegate loja = (LojaBusinessDelegate)delegate;
		List erros = new ArrayList();
		
		String codigo = request.getParameter("codigo");
		String qteStr = request.getParameter("qte");
		if (codigo == null) {
			erros.add("Codigo do produto a ser adicionado nao foi informado.");
			request.setAttribute("erros", erros);
			return failureUrl;
		}
		
		int quantidade = 1;
		if (qteStr != null) {
			try {
				quantidade = Integer.parseInt(qteStr.trim());
			} catch (NumberFormatException e) { /* default eh 1 */ }
		}
		
		try {
			System.out.println("Antes servlet");
			loja.adicionarProdutosCarrinho(codigo.trim(), quantidade);
			System.out.println("Depois servlet");
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
		return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof AdicionarProdutoCarrinhoCommand) ) return false;
        AdicionarProdutoCarrinhoCommand cmd = (AdicionarProdutoCarrinhoCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
