package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * Verifica se cliente esta autenticado. Se nao estiver, falha.
 * $Revision: 1.2 $ $Date: 2003/05/26 08:22:22 $ (helder@acm.org).
 */
public class AutenticarCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public AutenticarCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		ClienteVO cliente = (ClienteVO)request.getSession().getAttribute("cliente"); // ha sessao do cliente?
		
		if (cliente == null) { // nao
			return failureUrl; // faca algo - login, cadastro, etc.
		}
		return successUrl;
		
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof AutenticarCommand) ) return false;
        AutenticarCommand cmd = (AutenticarCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
