package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * Simple redirection.
 * $Revision: 1.2 $ $Date: 2003/05/25 21:06:05 $ (helder@acm.org).
 */
public class ClienteCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ClienteCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		String cmd = request.getParameter("cmd");
		List erros = new ArrayList();
		ClienteVO cliente = (ClienteVO) request.getAttribute("cliente");
		
		if (cliente == null) { // cria novo objeto (fora da sessao)
			cliente = new ClienteVO("","","","","","","");
		}
		
        String param = request.getParameter("userid");
		if (param != null) 
			cliente.setUserid(param.trim());
		param = request.getParameter("nome");
		if (param != null) 
			cliente.setNome(param.trim());
		param = request.getParameter("email");
		if (param != null) 
			cliente.setEmail(param.trim());
		param = request.getParameter("endereco");
		if (param != null) 
			cliente.setEndereco(param.trim());
		param = request.getParameter("senha");
		if (param != null) 
			cliente.setSenha(param.trim());
		param = request.getParameter("grupo");
		if (param != null) 
			cliente.setGrupo(param.trim());
		param = request.getParameter("cartao");
		if (param != null) 
			cliente.setCartao(param.trim());

		if (cmd.equals("form-editar-cliente")) {
			LoginBusinessDelegate login = (LoginBusinessDelegate)delegate;
			// Procura sessao do cliente
			cliente = (ClienteVO) request.getSession().getAttribute("cliente");
			String userid = cliente.getUserid();
			if (userid.equals("")) {
				erros.add("Sem userid nao posso atualizar cliente.");
				request.setAttribute("erros", erros);
				return failureUrl;
			} else {
				try {
					if (!login.existe(userid)) {
						erros.add("Cliente " + userid + " no existe!");
						request.setAttribute("erros", erros);
						return failureUrl;
					}
					cliente = login.mostrar(userid);
				} catch (LojaException e) {
					throw new CommandException("GravarClienteCommand: " + e);
				}
			}
			
		}
		
		request.setAttribute("cliente", cliente);
		return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ClienteCommand) ) return false;
        ClienteCommand cmd = (ClienteCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
