package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import loja.*;
import loja.web.*;

/**
 * Simple redirection.
 * $Revision: 1.1 $ $Date: 2003/05/25 15:53:03 $ (helder@acm.org).
 */
public class CompraCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public CompraCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

        String numero = request.getParameter("numero");
		String clienteId = request.getParameter("cliente");
		String status = request.getParameter("status");
		
		CompraVO compra = new CompraVO();
		compra.setNumero(numero);
		compra.setClienteId(clienteId);
		compra.setStatus(Status.getStatus(status));
		
		request.setAttribute("compra", compra);
		return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof CompraCommand) ) return false;
        CompraCommand cmd = (CompraCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
