package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.1 $ $Date: 2003/05/25 15:53:03 $ (helder@acm.org).
 */
public class DetalharCompraCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public DetalharCompraCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		AdminLojaBusinessDelegate loja = (AdminLojaBusinessDelegate)delegate;
		String numero = request.getParameter("numero");
		if (numero == null || numero.trim().length() == 0) {
			List erros = new ArrayList();
			erros.add("Nmero de nota est vazio! Selecione uma nota existente para alterar status.");
			request.setAttribute("erros", erros);
			return failureUrl;
		}
        try {
			CompraVO compra = loja.mostrarCompra(numero.trim());
            ItemVO[] valueObjects = compra.getItens();
            request.setAttribute("itens", valueObjects);
			request.setAttribute("compra", compra);
            return successUrl;
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof DetalharCompraCommand) ) return false;
        DetalharCompraCommand cmd = (DetalharCompraCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
