package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.2 $ $Date: 2003/05/24 02:02:08 $ (helder@acm.org).
 */
public class EsvaziarEstoqueCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public EsvaziarEstoqueCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		AdminLojaBusinessDelegate loja = (AdminLojaBusinessDelegate)delegate;
		String codigo = request.getParameter("codigo");
		if (codigo == null || codigo.trim().length() == 0) {
			List erros = new ArrayList();
			erros.add("Cdigo vazio! Selecione um codigo de produto existente para esvaziar estoque.");
			request.setAttribute("erro", erros);
			return failureUrl;
		}
		try {
			loja.esvaziarEstoque(codigo.trim());
		} catch (LojaException e) {
			throw new CommandException(e);
		}
		return successUrl;
    }
    
    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof EsvaziarEstoqueCommand) ) return false;
        EsvaziarEstoqueCommand cmd = (EsvaziarEstoqueCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
