package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.ArrayList;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.2 $ $Date: 2003/05/26 08:22:22 $ (helder@acm.org).
 */
public class ListarCarrinhoCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ListarCarrinhoCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    /**
     * Reads all messages from XML files.
     */
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {
		System.out.println("ListarCarrinhoCommand");
		
		LojaBusinessDelegate loja = (LojaBusinessDelegate)delegate;
        try {
			// Este VO nao possui objeto compra
            ItemVO[] carrinho = loja.listarConteudoCarrinho();
            request.setAttribute("carrinho", carrinho);
			
			// Este VO nao possui codigo nem cliente
			CompraVO compra = new CompraVO();
			compra.setItens(carrinho);
			request.setAttribute("compra", compra);
			
            return successUrl;
        } catch (Exception e) {
            throw new CommandException(e);
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ListarCarrinhoCommand) ) return false;
        ListarCarrinhoCommand cmd = (ListarCarrinhoCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
