package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.3 $ $Date: 2003/05/26 09:17:05 $ (helder@acm.org).
 */
public class ListarComprasCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ListarComprasCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    /**
     * Reads all messages from XML files.
     */
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		String cmd = request.getParameter("cmd");
		AdminLojaBusinessDelegate loja = (AdminLojaBusinessDelegate)delegate;
		List erros = new ArrayList();
		
        try {
			CompraVO[] valueObjects = null;
			if (cmd.equals("acao-listar-compras")) {
				// verificar se usuario pertence ao grupo admin
				
				valueObjects = loja.listarCompras();
			} else if (cmd.equals("acao-listar-compras-cliente")) {
				ClienteVO cliente = (ClienteVO)request.getSession().getAttribute("cliente");
				if (cliente == null) {
					erros.add("Sesso inexistente ou expirada. Faa login!");
					request.setAttribute("erros", erros);
					return failureUrl;
				}
				request.setAttribute("cliente", cliente);
				valueObjects = loja.listarCompras(cliente.getUserid());
			}
            request.setAttribute("compras", valueObjects);
            return successUrl;
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ListarComprasCommand) ) return false;
        ListarComprasCommand cmd = (ListarComprasCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
