package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.ArrayList;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.4 $ $Date: 2003/05/26 08:22:23 $ (helder@acm.org).
 */
public class ListarProdutosCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ListarProdutosCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		String cmd = request.getParameter("cmd");
		
        try {
			ProdutoVO[] valueObjects = new ProdutoVO[0];
			if (cmd.equals("acao-listar-estoque")) {
				AdminLojaBusinessDelegate loja = (AdminLojaBusinessDelegate)delegate;
				valueObjects = loja.listarProdutos();
			} else if (cmd.equals("acao-listar-produtos")) {
				LojaBusinessDelegate loja = (LojaBusinessDelegate)delegate;
				valueObjects = loja.listarProdutosDisponiveis();
			}
			request.setAttribute("produtos", valueObjects);
            return successUrl;
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ListarProdutosCommand) ) return false;
        ListarProdutosCommand cmd = (ListarProdutosCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
