package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.ArrayList;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.1 $ $Date: 2003/05/25 15:53:04 $ (helder@acm.org).
 */
public class ListarStatusCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ListarStatusCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		Status[] allStatus = Status.allStatus();
		String[] allAsString = new String[allStatus.length];
		for (int i = 0; i < allAsString.length; i++) {
			allAsString[i] = allStatus[i].toString();
		}
		request.setAttribute("status", allAsString);
		
		String numero = request.getParameter("numero");
		String status = request.getParameter("status");
		
		CompraVO compra = new CompraVO();
		compra.setNumero(numero.trim());
		compra.setStatus(Status.getStatus(status.trim()));
		
		request.setAttribute("compra", compra);
		
		return successUrl;
		
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ListarStatusCommand) ) return false;
        ListarStatusCommand cmd = (ListarStatusCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
