package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.1 $ $Date: 2003/05/25 15:53:05 $ (helder@acm.org).
 */
public class RemoverClienteCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public RemoverClienteCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {

		AdminLojaBusinessDelegate loja = (AdminLojaBusinessDelegate)delegate;

		String userid = request.getParameter("userid");
		if (userid == null || userid.trim().length() == 0) {
			List erros = new ArrayList();
			erros.add("Userid vazio! Selecione ID de usuario existente para remover.");
			request.setAttribute("erros", erros);
			return failureUrl;
		}
		try {
			loja.removerCliente(userid.trim());
		} catch (LojaException e) {
			throw new CommandException(e);
		}
		return successUrl;
    }
    
    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof RemoverClienteCommand) ) return false;
        RemoverClienteCommand cmd = (RemoverClienteCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
