package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.2 $ $Date: 2003/05/26 08:22:23 $ (helder@acm.org).
 */
public class RemoverProdutoCarrinhoCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public RemoverProdutoCarrinhoCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {
		LojaBusinessDelegate loja = (LojaBusinessDelegate)delegate;
		List erros = new ArrayList();
		
		String cmd = request.getParameter("cmd");

        try {
            if (cmd.equals("acao-remover-do-carrinho")) {
				String codigo = request.getParameter("codigo");
				if (codigo == null) {
					erros.add("Codigo do produto a ser removido nao foi informado.");
					request.setAttribute("erros", erros);
					return failureUrl;
				}
				loja.removerProdutosCarrinho(codigo);
			} else	if (cmd.equals("acao-esvaziar-carrinho")) {
				loja.esvaziarCarrinho();
			}
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
		return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof RemoverProdutoCarrinhoCommand) ) return false;
        RemoverProdutoCarrinhoCommand cmd = (RemoverProdutoCarrinhoCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
