package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import loja.*;
import loja.web.*;

/**
 * Simple redirection.
 * $Revision: 1.1 $ $Date: 2003/05/25 15:53:05 $ (helder@acm.org).
 */
public class ServletRedirectCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ServletRedirectCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, BusinessDelegate delegate) throws CommandException {
		return request.getServletPath() + successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ServletRedirectCommand) ) return false;
        ServletRedirectCommand cmd = (ServletRedirectCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
