package loja.web.taglib;

import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;

public class ErrosTag extends TagSupport {
	
	private static final String ERROS_ATTRIBUTE = "erros";
	
	private String prefix = "";
	private String suffix = "";
	
	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}
	
	public void setSuffix(String suffix) {
		this.suffix = suffix;
	}

    public int doEndTag() throws JspException {
        try {
			Object obj = pageContext.getRequest().getAttribute(ERROS_ATTRIBUTE);
			if (obj != null) {
				List erros = (List) obj;
				JspWriter out = pageContext.getOut();
				Iterator it = erros.iterator();
				while(it.hasNext()) {
					out.println(prefix + it.next() + suffix);
				}
			}
        } catch (java.io.IOException e) {
            throw new JspException (e);
        }
        return Tag.EVAL_PAGE;
    }
	
	public void release() {
        super.release();
        prefix = null;
		suffix = null;
    }
}
