package loja.web.taglib;

import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;

public class ListaTag extends TagSupport {
	
	private String startTag = "";
	private String endTag = "";
	private String[] array = null;
	
	public void setArray(String arrayAttribute) {
		array = (String[])pageContext.getRequest().getAttribute(arrayAttribute);
	}
	
	public void setTag(String tag) {
		this.startTag = "<"+tag+">";
		this.endTag  = "</"+tag+">\n";
	}

    public int doEndTag() throws JspException {
        try {
			JspWriter out = pageContext.getOut();
			if (array != null) {
				for (int i = 0; i < array.length; i++) {
					out.println(startTag + array[i] + endTag);
				}
			}
        } catch (java.io.IOException e) {
            throw new JspException (e);
        }
        return Tag.EVAL_PAGE;
    }
	
	public void release() {
        super.release();
        startTag = null;
		endTag = null;
    }
}
