package com.sun.ebank.appclient;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Esta classe oferece um dilogo grfico para ler o 
 * nome de usurio e senha no cliente.
 */
public class LoginDialog {

    private String title, message, passLabel, nameLabel;
    private String name, pass;
    private boolean closed = false;
    
    private JDialog dialog;
    
    public LoginDialog(String title, String message, String nameLabel, String passLabel) {
        dialog = new JDialog((JFrame)null, title, true);
        this.title = title;
        this.message = message;
        this.passLabel = passLabel;
        this.nameLabel = nameLabel;
    }
    
    public LoginDialog(String message) {
        this("Login", message, "Name", "Password");
    }
    
    public LoginDialog() {
        this("Login", "", "Name", "Password");
    }
    
    private void makeGUI() {
        dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        dialog.getContentPane().setLayout(new BorderLayout(5, 5));

        JLabel msg = new JLabel(message);
        JLabel nm = new JLabel(nameLabel);
        JLabel ps = new JLabel(passLabel);
        JPanel labels = new JPanel(new GridLayout(2, 1, 2, 2));
        labels.add(nm);
        labels.add(ps);
        
        final JTextField nmField = new JTextField(15);
        final JTextField psField = new JTextField(15);
        JPanel fields = new JPanel(new GridLayout(2, 1, 2, 2));
        fields.add(nmField);
        fields.add(psField);
        
        JButton ok = new JButton("Login");
        ok.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                name = nmField.getText();
                pass = psField.getText();
                dialog.dispose();
                dialog = null;
            }
        });
        JButton cancel = new JButton("Abort");
        cancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(1);
            }
        });
        JPanel buttons = new JPanel();
        buttons.add(ok);
        buttons.add(cancel);
        
        dialog.getContentPane().add(BorderLayout.NORTH, msg);
        dialog.getContentPane().add(BorderLayout.SOUTH, buttons);
        dialog.getContentPane().add(BorderLayout.WEST, labels);
        dialog.getContentPane().add(BorderLayout.CENTER, fields);

        dialog.pack();
        dialog.setLocation(300,300);
        dialog.setVisible(true); 
    }
    
    public String[] getData() {
        makeGUI();
        return new String[] {name, pass};
    }
    
    /**
     * Mtodo para testar a classe
     */
    public static void main(String[] args) {
        LoginDialog d = new LoginDialog("Digite seus dados");
        String[] pair = d.getData();
        System.out.println("Read: [0] = " + pair[0] + ", [1] = " + pair[1]);
    }
}
