package loja.ejb;

import javax.ejb.*;
import javax.jms.*;
import java.util.*;

import loja.integration.ServiceLocator;
import loja.LojaException;

public class ControleEstoqueMDB implements MessageDrivenBean, MessageListener {
	
	private ProdutoHome produtoHome;
	private MessageDrivenContext ctx;
	
	public void ejbCreate() {
		try {
			System.out.println("ControleEstoqueMDB: ejbCreate()");
			ServiceLocator locator = ServiceLocator.getInstance();
			produtoHome = (ProdutoHome)locator.findRemoteEJB("ejb/loja-simples/produto", ProdutoHome.class);
		} catch (LojaException e) {
			System.out.println("ControleEstoqueMDB-ejbCreate(): " + e);
		}
	}
	
	public void ejbRemove() {}
	public void setMessageDrivenContext(MessageDrivenContext ctx) {
		System.out.println("setMessageDrivenContext()");
		this.ctx = ctx;
	}
	
	public void onMessage(Message message) {
		System.out.println("AdminLojaSessionFacadeBean: onMessage("+message+")");
		try {
			if (message instanceof TextMessage) {
				TextMessage textMessage = (TextMessage) message;
				String text = textMessage.getText();
				
				StringTokenizer tokenizer = new StringTokenizer(text, "|");
				if (tokenizer.hasMoreTokens()) {
					String codigo = tokenizer.nextToken();
					int quantidade = Integer.parseInt(tokenizer.nextToken());
					Produto produto = produtoHome.findByPrimaryKey(new ProdutoPK(codigo));
					produto.addItens(quantidade);
				}
			}
		} catch (JMSException e) {
			System.out.println("ControleEstoqueMDB-onMessage(): " + e);
		} catch (FinderException e) {
			System.out.println("ControleEstoqueMDB-onMessage(): " + e);
		} catch (java.rmi.RemoteException e) {
			System.out.println("ControleEstoqueMDB-onMessage(): " + e);
		}
	}
}
