package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.ArrayList;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.3 $ $Date: 2002/10/06 14:25:00 $ (helder@acm.org).
 */
public class ListarProdutosCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public ListarProdutosCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    /**
     * Reads all messages from XML files.
     */
    public Object execute(HttpServletRequest request, HttpServletResponse response, AdminLojaBusinessDelegate loja) throws CommandException {
        try {
            ProdutoVO[] valueObjects = loja.listarProdutos();
            request.setAttribute("produtos", valueObjects);
            return successUrl;
        } catch (LojaException e) {
            throw new CommandException(e);
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ListarProdutosCommand) ) return false;
        ListarProdutosCommand cmd = (ListarProdutosCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
