package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import loja.*;
import loja.web.*;

/**
 * Simple redirection.
 * $Revision: 1.3 $ $Date: 2002/10/06 14:24:59 $ (helder@acm.org).
 */
public class RedirectCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public RedirectCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, AdminLojaBusinessDelegate loja) throws CommandException {
        String codigo = request.getParameter("codigo");
		String nome = request.getParameter("nome");
		String preco = request.getParameter("preco");
		String quantidade = request.getParameter("quantidade");
		int qte = 0;
		if (quantidade != null) {
			try {
				qte = Integer.parseInt(quantidade.trim());
			} catch (NumberFormatException e) {}
		}
		double precoDbl = 0.0;
		if (preco != null) {
			try {
				precoDbl = Double.parseDouble(preco.trim());
			} catch (NumberFormatException e) {}
		}
		if (codigo != null && quantidade != null && preco != null && nome != null) {
			ProdutoVO produto = new ProdutoVO(codigo.trim(), nome.trim(), new java.math.BigDecimal(precoDbl), qte);
			request.setAttribute("produto", produto);
		}
		return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof RedirectCommand) ) return false;
        RedirectCommand cmd = (RedirectCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
