package loja.web.command;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import loja.*;
import loja.web.*;

/**
 * $Revision: 1.3 $ $Date: 2002/10/06 14:24:59 $ (helder@acm.org).
 */
public class RemoverProdutoCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public RemoverProdutoCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, AdminLojaBusinessDelegate loja) throws CommandException {

		String codigo = request.getParameter("codigo");
		if (codigo == null || codigo.trim().length() == 0) {
			List erros = new ArrayList();
			erros.add("Cdigo vazio! Selecione um codigo de produto existente para remover.");
			request.setAttribute("erros", erros);
			return failureUrl;
		}
		try {
			loja.removerProduto(codigo.trim());
		} catch (LojaException e) {
			throw new CommandException(e);
		}
		return successUrl;
    }
    
    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof RemoverProdutoCommand) ) return false;
        RemoverProdutoCommand cmd = (RemoverProdutoCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
