package loja.web.taglib;

import javax.servlet.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;

public class ErrosTag extends TagSupport {
	
	private static final String ERROS_ATTRIBUTE = "erros";
	
	private String startTag = "";
	private String endTag = "";
	
	public void setTag(String tag) {
		this.startTag = "<"+tag+">";
		this.endTag  = "</"+tag+">\n";
	}

    public int doEndTag() throws JspException {
        try {
			Object obj = pageContext.getRequest().getAttribute(ERROS_ATTRIBUTE);
			if (obj != null) {
				List erros = (List) obj;
				JspWriter out = pageContext.getOut();
				Iterator it = erros.iterator();
				while(it.hasNext()) {
					out.println(startTag + it.next() + endTag);
				}
			}
        } catch (java.io.IOException e) {
            throw new JspException (e);
        }
        return Tag.EVAL_PAGE;
    }
	
	public void release() {
        super.release();
        startTag = null;
		endTag = null;
    }
}
